
#include <stdio.h>
#include "AudioSesssions_framework.h"

void printLoadingTicker( void );
// This expects HRESULT from the function to be called result
//#define checkHRESULT(func) if((func) != S_OK) printf("\nError on line %d of %s. Result value is %lx.\n", __LINE__, __FILE__, result);
#define checkHRESULT if(result != S_OK) printf("\nError on line %d of %s. Result value is %lx.\n", __LINE__ - 1, __FILE__, result);


int main(void)
{
	printf("Compiled %s", __TIME__);
	printf("\nStarting");

	/*
	The audio sessions information strut contains all the information needed to perform actions on the audio streams
	The IMM enumerator of all IMM devices
	This includes the IMM interface to the default audio device
	The number of open audio sessions at any time
	A pointer to block of memory containing an array of pointers to audio session control interfaces
	*/
	AudioSessionsInformation AudioSessionsInformation = {.AudioSessionControlsCollection = NULL, .NumberAudioSessionsActive = 0};
	
	initialiseSessionsFramework(&AudioSessionsInformation);

	int numberSessionControls = 0;
	while (1)
	{
		Sleep(50);
		if (AudioSessionsInformation.NumberAudioSessionsActive != numberSessionControls)
		{
			printf("\nNew Session control added");
			for (int i = 0; i < AudioSessionsInformation.NumberAudioSessionsActive; i++)
			{
				LPWSTR IconPath = NULL;
				//AudioSessionsInformation.AudioSessionControlsCollection[i]->lpVtbl->GetDisplayName(AudioSessionsInformation.AudioSessionControlsCollection[i],
				//	&IconPath);
				//printf("\nIcon path of session %d is: %ws", i, IconPath);

				AudioSessionsInformation.AudioSessionControlsCollection[i]->lpVtbl->GetDisplayName(AudioSessionsInformation.AudioSessionControlsCollection[i],
					&IconPath);
				printf("\nName of session %d is: %ws", i, IconPath);
			}

			numberSessionControls = AudioSessionsInformation.NumberAudioSessionsActive;
		}

	}
	printf("\nFinished");
	return S_OK;
}


void printLoadingTicker(void)
{
	static count = 0;

	char loadChar = ' ';
	switch (count % 8)
	{
	case(0):
		loadChar = '|';
		break;
	case(1):
		loadChar = '/';
		break;
	case(2):
		loadChar = '-';
		break;
	case(3):
		loadChar = '\\';
		break;
	case(4):
		loadChar = '|';
		break;
	case(5):
		loadChar = '/';
		break;
	case(6):
		loadChar = '-';
		break;
	case(7):
		loadChar = '\\';
		break;
	default:
		break;
	}

	printf("Checking for new sessions [%c]\r", loadChar);
	count++;

	return;
}